package com.capgemini.shop.business;

import com.capgemini.shop.common.*;
import java.io.IOException;
import java.util.Enumeration;
import javax.servlet.*;
import javax.servlet.http.*;

/** Servlet front strategy, from Core J2EE patterns */
public class Controller extends HttpServlet
{
	/** Initializes the servlet */
	public void init(ServletConfig config) throws ServletException 
	{
		super.init(config);
	}

	/** Destroys the servlet */
	public void destroy(){}

	/** Processes requests for both HTTP-GET and HTTP-POST methods
	 *  @param request servlet request
	 *  @param response servlet response 
	 */
	protected void processRequest(HttpServletRequest request,
		HttpServletResponse response) throws ServletException, IOException 
		{
	String page = "order.jsp";
	try 
	{
		EjbDelegate delegate 
			= (EjbDelegate) request.getSession().getAttribute("delegate");

		if (delegate == null) 
		{ 
			delegate = new EjbDelegate();
			request.getSession().setAttribute("delegate", delegate);
			
			Logger.debug("Controller", "Started new session");
			
			Enumeration enumeration = request.getParameterNames();
			while (enumeration.hasMoreElements()) 
			{
				String key = enumeration.nextElement() + "";
				Logger.debug("Controller", key + "=\"" + request.getParameter(key) + "\"");
			}
		}

		Command command = delegate.getCommand(request);
		request.getSession().setAttribute( "commandexecuting", new Object() );
		Logger.debug("Controller", "execute:" + command);
		page = command.execute(request);
		
	} // try
	catch (Exception e) 
	{
		e.printStackTrace();
	}

	// Dispatch control to view
	dispatch(request, response, page);
}

	/** Handles the HTTP-GET method */
	protected void doGet(HttpServletRequest request, HttpServletResponse response)
		throws ServletException, IOException 
		{
			processRequest(request, response);
		}

	/** Handles the HTTP-POST method */
	protected void doPost(HttpServletRequest request, HttpServletResponse response)
		throws ServletException, IOException 
		{
			processRequest(request, response);
		}

	/** Returns a short description of the servlet */
	public String getServletInfo() 
	{
		return("Front controller of the MC-Info Work Book application");
	}

	protected void dispatch(HttpServletRequest request, 
		HttpServletResponse response, String page)
		throws ServletException, IOException 
		{
			RequestDispatcher dispatcher;
			if (page.charAt(0) == '/')
			{
				dispatcher = getServletContext().getRequestDispatcher(page);
			}
			else 
			{
				Logger.debug("Controller",
					page + ": doesn't start with '/'");
				dispatcher = getServletContext().getRequestDispatcher("/" + page);
			}
			Logger.debug("Controller", "forward...");
			dispatcher.forward(request, response);
		}

}
