package com.capgemini.shop.business;

import com.capgemini.shop.common.*;
import com.capgemini.shop.view.*;
import java.rmi.RemoteException;
import javax.naming.InitialContext;
import javax.servlet.http.HttpServletRequest;

/**
 * Communicates with the EJB and commands.
 */
public class EjbDelegate
{
	private ShopejbRemote remote = null;

	public EjbDelegate()
	{
		ShopejbHome home;
		try
		{
			InitialContext initialcontext = new InitialContext();
			home = (ShopejbHome) initialcontext.lookup("java:comp/env/ejb/Shopejb");
			remote = home.create();
		} // try
		catch (Exception e)
		{
			e.printStackTrace();
		} // catch
	}

	public Command getCommand(HttpServletRequest request)
	{
                String view = (String) request.getSession().getAttribute("current_view");
		Logger.debug("EjbDelegate","view: " + view);
		if ( (view == null) || (view.equals("shop")) )
		{
			return ( new OrderMainCommands() );
		}
		else
		{
			Logger.debug("EjbDelegate","unknown command");
			return ( null );
		}
	} // getCommand()

	public void executeCommand(View view)
	{
		try
		{
			remote.executeCommand(view);
		}
		catch (RemoteException e)
		{
			e.printStackTrace();
		}
	} // executeCommand()()
        
	public OrderMainHelper getOrderMainHelper()
	{
		try
		{
			return( remote.getOrderMainHelper() );
		}
		catch (RemoteException e)
		{
			e.printStackTrace();
			return( null );
		}
	} // getOrderMainHelper()

} // class
