package com.capgemini.shop.database;

import java.io.Serializable;

import java.util.LinkedList;
import java.util.List;

/**
 * Implements one order main object, corresponds the database table ORDER_MAIN.
 * &quot;One order (for one person)&quot;
 */
public class OrderMainValue implements Serializable
{
  //The class attributes
  private String address = null;
  private String phone_number = null;
  private String name = null;
  private int id = -1; // The primary key
  private List<OrderProductReferenceValue> product_list = null;

  public String getAddress()
  {
    return (address);
  }

  public void setAddress(String data)
  {
    this.address = data;
  }

  public String getPhoneNumber()
  {
    return (phone_number);
  }

  public void setPhoneNumber(String data)
  {
    this.phone_number = data;
  }

  public String getName()
  {
    return (name);
  }

  public void setName(String data)
  {
    this.name = data;
  }

  public int getId()
  {
    return (id);
  }

  public void setId(int data)
  {
    this.id = data;
  }
  
  public void setProductList(List<OrderProductReferenceValue> data)
  {
    product_list = data;
  }
  
  public List<OrderProductReferenceValue> getProductList()
  {
    return(product_list);
  }
  
  public void addProduct(OrderProductReferenceValue data)
  {
    if (product_list == null)
    {
      product_list = new LinkedList<OrderProductReferenceValue>();
    }
    
    product_list.add(data);
  }
}
