package com.capgemini.shop.view;

import com.capgemini.shop.common.*;
import com.capgemini.shop.business.EjbDelegate;

import java.util.Enumeration;

import javax.servlet.http.HttpServletRequest;

/**
 * Communicates with the EJB via delegate and collects data from front (user) to back (EJB).
 * &quot;One order (for one person)&quot;
 */
public class OrderMainCommands implements Command
{
	public String execute(HttpServletRequest request)
	{
		OrderMainView view = new OrderMainView();
                Enumeration enumeration = request.getParameterNames();
                while (enumeration.hasMoreElements()) 
                {
                        String key = enumeration.nextElement().toString();
                        view.addParameter(key, request.getParameter(key));
                }

		if (request.getSession().getAttribute("delegate") != null)
		{
			EjbDelegate delegate = (EjbDelegate) request.getSession().getAttribute("delegate");

			delegate.executeCommand(view);
			OrderMainHelper helper = delegate.getOrderMainHelper();

			if (helper != null)
			{
				request.setAttribute("pagebean",helper);
				return("order.jsp");
			} // if helper != null

		} // if delegate != null

		return("reset.jsp");
	} // execute()
} // class
